%define name    cacti
%define version 0.8.7b
%define release %mkrel 4

%define _requires_exceptions pear(/usr/share/php-adodb/adodb.inc.php)

Name:       %{name}
Version:    %{version}
Release:    %{release}
Summary:    Php frontend for rrdtool
License:    GPL
Group:      System/Servers
URL:        http://www.cacti.net
Source0:    http://www.cacti.net/downloads/%{name}-%{version}.tar.gz
Patch0:     cacti-0.8.7b-fhs.patch
Patch1:     cacti-0.8.6i-use_external_adodb.patch
Patch3:     cacti-0.8.7b-fhs-PA.patch
Requires:   apache-mod_php >= 2.0.54
Requires:   php-adodb >= 1:4.64-1mdk
Requires:   php-cli
Requires:   php-gd
Requires:   php-mysql
Requires:   php-snmp
Requires:   php-xml
Requires:   net-snmp-utils
Requires:   net-snmp
Requires:   rrdtool
# webapp macros and scriptlets
Requires(post):     rpm-helper >= 0.16-2mdv2007.0
Requires(postun):   rpm-helper >= 0.16-2mdv2007.0
BuildRequires:  rpm-helper >= 0.16-2mdv2007.0
BuildRequires:  rpm-mandriva-setup >= 1.23-1mdv2007.0
BuildArch:  noarch
BuildRoot:  %{_tmppath}/%{name}-%{version}

%description
Cacti is a complete frondend to rrdtool, it stores all of the
nessesary information to create graphs and populate them with
data in a MySQL database.

The frontend is completely PHP driven. Along with being able
to maintain Graphs, Data Sources, and Round Robin Archives in
a database, cacti handles the data gathering also. There is
also SNMP support for those used to creating traffic graphs
with MRTG.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch3 -p1

# fix perms
find . -type d | xargs chmod 755
find . -type f | xargs chmod 644
chmod +x scripts/*.{pl,sh}
chmod +x poller.php cmd.php

%build

%install
rm -rf %{buildroot}

install -d -m 755 %{buildroot}%{_var}/www/%{name}
install -d -m 755 %{buildroot}%{_datadir}/%{name}
install -d -m 755 %{buildroot}%{_localstatedir}/lib/%{name}
install -d -m 755 %{buildroot}%{_sysconfdir}

cp *.php %{buildroot}%{_var}/www/%{name}
# those are not required under web root
for file in {poller*,cmd}.php; do
    rm -f %{buildroot}%{_var}/www/%{name}/$file
    cp $file %{buildroot}%{_datadir}/%{name}
done
cp -pr docs %{buildroot}%{_var}/www/%{name}
cp -pr images %{buildroot}%{_var}/www/%{name}
cp -pr install %{buildroot}%{_var}/www/%{name}
cp -pr scripts %{buildroot}%{_datadir}/%{name}
cp -pr resource %{buildroot}%{_datadir}/%{name}
cp -pr lib %{buildroot}%{_datadir}/%{name}
cp -p cacti.sql %{buildroot}%{_datadir}/%{name}


# distribut include content
cp -p include/config.php %{buildroot}%{_sysconfdir}/%{name}.conf
find include -type f -a -name '*.php' -a -not -name 'config.php' | \
    tar --create --files-from - --remove-files | \
    (cd %{buildroot}%{_datadir}/%{name} && tar --preserve --extract)
find include -type f -a -not -name '*.php' -a -not -name 'config.php' | \
    tar --create --files-from - --remove-files | \
    (cd %{buildroot}%{_var}/www/%{name} && tar --preserve --extract)

# distribute install content
install -d -m 755 %{buildroot}%{_datadir}/%{name}/upgrade
mv %{buildroot}%{_var}/www/%{name}/install/*_to_*.php %{buildroot}%{_datadir}/%{name}/upgrade

# apache configuration
install -d -m 755 %{buildroot}%{_webappconfdir}
cat > %{buildroot}%{_webappconfdir}/%{name}.conf <<EOF
# Cacti Apache configuration file
Alias /%{name} %{_var}/www/%{name}
<Directory %{_var}/www/%{name}>
    Allow from all
</Directory>
EOF

# cron task
install -d -m 755 %{buildroot}%{_sysconfdir}/cron.d
cat > %{buildroot}%{_sysconfdir}/cron.d/%{name} <<EOF
#!/bin/sh
*/5 * * * *     apache     php %{_datadir}/%{name}/poller.php > /dev/null 2>&1
EOF

# logs
install -d -m 755 %{buildroot}%{_var}/log/%{name}
install -d -m 755 %{buildroot}%{_sysconfdir}/logrotate.d
cat > %{buildroot}%{_sysconfdir}/logrotate.d/%{name} <<EOF
%{_var}/log/%{name}/*.log {
    missingok
    compress
}
EOF

rm -rf %{buildroot}%{_datadir}/%{name}/lib/adodb

cat > README.mdv <<EOF
Mandriva RPM specific notes

setup
-----
The setup used here differs from default one, to achieve better FHS compliance.
- the configuration file is /etc/cacti.conf
- the log files are in /var/log/cacti
- the files accessibles from the web are in /var/www/cacti
- the files non accessibles from the web are in /usr/share/cacti

post-installation
-----------------
You have to create the MySQL database using the file /usr/share/cacti/cacti.sql.

Additional useful packages
--------------------------
- a MySQL database, either locale or remote
EOF

%clean
rm -rf %{buildroot}

%pre
if [ $1 = "2" ]; then
    # fix for old setup
    if [ -L %{_var}/www/%{name}/include ]; then
        rm -f %{_var}/www/%{name}/include
    fi
fi

%post
%_post_webapp

%postun
%_postun_webapp

%files
%defattr(-,root,root)
%doc LICENSE README.mdv docs/CHANGELOG docs/CONTRIB docs/README
%config(noreplace) %{_webappconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{_sysconfdir}/cron.d/%{name}
%{_var}/www/%{name}
%{_datadir}/%{name}
%attr(-,apache,apache) %{_localstatedir}/lib/%{name}
%attr(-,apache,apache) %{_var}/log/%{name}




%changelog
* Thu Aug 07 2008 Thierry Vignaud <tvignaud@mandriva.com> 0.8.7b-4mdv2009.0
+ Revision: 266444
- rebuild early 2009.0 package (before pixel changes)

  + Pixel <pixel@mandriva.com>
    - adapt to %%_localstatedir now being /var instead of /var/lib (#22312)

* Sat May 24 2008 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.7b-3mdv2009.0
+ Revision: 210979
- update FHS patch for missing included file (fix #40862)
- update FHS patch for upgrade scripts

* Mon Mar 31 2008 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.7b-2mdv2008.1
+ Revision: 191186
- don't make cron task executable

* Fri Feb 29 2008 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.7b-1mdv2008.1
+ Revision: 176798
- new version
  update FHS and PA patches

* Mon Feb 18 2008 Thierry Vignaud <tvignaud@mandriva.com> 0.8.7a-4mdv2008.1
+ Revision: 170781
- rebuild
- fix "foobar is blabla" summary (=> "blabla") so that it looks nice in rpmdrake

* Wed Jan 23 2008 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.7a-3mdv2008.1
+ Revision: 157170
- fix default URL root (fix #36617)

* Thu Jan 17 2008 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.7a-2mdv2008.1
+ Revision: 154062
- rediff fhs patch
  ifix _adodb.patch (should fix #36617)

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Wed Nov 28 2007 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.7a-1mdv2008.1
+ Revision: 113789
- new version
  rediff FHS patch
  apply Plugin Architecture patch from http://cactiusers.org/downloads/plugins/

  + Buchan Milne <bgmilne@mandriva.org>
    - New version 0.8.7
    - Drop LDAP protocol patch (protocol version support added upstream)
    - Add plugin patch from cactiusers.org (and the tarball it ships in)

* Fri Aug 17 2007 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6j-1mdv2008.0
+ Revision: 65370
- remove eol fixing, as done by spec-helper
- new version


* Sat Oct 21 2006 Jérôme Soyer <saispo@mandriva.org> 0.8.6i-1mdv2007.0
+ Revision: 71585
- New release 0.8.6i
- Import cacti

* Wed Jul 12 2006 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6h-6mdv2007.0
- use herein document for README.mdv

* Sat Jul 01 2006 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6h-5mdv2007.0
- relax buildrequires versionning

* Tue Jun 27 2006 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6h-4mdv2007.0
- new webapps macros
- decompress all patches

* Fri Mar 17 2006 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6h-3mdk
- add patch to allow to select LDAP protocol
- fix included adodb removal
- backport compatible apache configuration file

* Mon Feb 27 2006 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6h-2mdk
- fixes from J.P. Pasnak <pasnak@warpedsystems.sk.ca> (fix bug #21125)
 - rediff patch 0
 - move some additional files out of webroot

* Tue Jan 10 2006 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6h-1mdk
- New release 0.8.6h
- rediff patch 0

* Mon Dec 05 2005 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6g-3mdk
- move new poller scripts to /usr/share/cacti (fix bug #20065)
- rediff patch 0
- don't backup files before patching

* Thu Dec 01 2005 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6g-2mdk
- rediff patch 0 (fix 0.8.6f -> 0.8.6g upgrade)

* Sun Nov 06 2005 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6g-1mdk
- New release 0.8.6g
- rediff and merge patches 0, 2 and 3

* Wed Aug 17 2005 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6f-3mdk
- rediff patch 3 to avoid false automatic pear dependencies

* Wed Aug 17 2005 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6f-2mdk
- fix remaining wrong includes (fix bug #5423)

* Wed Jul 20 2005 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6f-1mdk 
- new version
- fix upgrade
- fix include path
- mv upgrade libraries outside of www root

* Thu Jun 30 2005 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6e-3mdk 
- use new rpm apache macros
- rediff patch 1 for new adodb
- only fix encoding for text files
- let rpm compute dependencies

* Thu Jun 23 2005 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6e-2mdk 
- drop redundant requires 
- drop additional sources, herein documents are used
- safer %%post and %%postun
- don't use dos2unix
- use patch instead of symlinks for FHS compliance
- split include between /usr/share/cacti and /var/www/cacti
- remove script from webroot

* Thu Jun 23 2005 Oden Eriksson <oeriksson@mandriva.com> 0.8.6e-1mdk
- 0.8.6e (Major security fixes)
- fix apache changes
- use the %%mkrel macro

* Mon May 16 2005 Oden Eriksson <oeriksson@mandriva.com> 0.8.6d-4mdk
- don't trash images

* Mon May 16 2005 Oden Eriksson <oeriksson@mandriva.com> 0.8.6d-3mdk
- fix config
- fix reload

* Fri May 13 2005 Guillaume Rousse <guillomovitch@mandriva.org> 0.8.6d-2mdk 
- fix upgrading from 0.8.6c-5mdk and prior releases

* Wed May 11 2005 Oden Eriksson <oeriksson@mandriva.com> 0.8.6d-1mdk
- 0.8.6d
- rediff P0, P1 & P2
- fix deps
- use better anti ^M stripper

* Sat Apr 09 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 0.8.6c-10mdk
- fix #13964

* Sat Apr 09 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 0.8.6c-9mdk
- fix #13963

* Fri Feb 18 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 0.8.6c-8mdk
- spec file cleanups, remove the ADVX-build stuff
- fix rpmlint errors

* Mon Jan 31 2005 Guillaume Rousse <guillomovitch@mandrake.org> 0.8.6c-7mdk 
- fix configuration patch

* Sat Jan 29 2005 Guillaume Rousse <guillomovitch@mandrake.org> 0.8.6c-6mdk 
- fix inclusion pathes (Gilles Mocellin <cooker@gmocellin.dyndns.org>)
- move include and lib to /usr/share/cacti
- fix post-install and post-uninstall

* Thu Jan 27 2005 Guillaume Rousse <guillomovitch@mandrake.org> 0.8.6c-5mdk 
- top-level dir is now /var/www/cacti
- config is now in /etc
- reload apache instead of restarting it
- herein document instead of external source for apache config
- don't tag executables in /etc as config
- README.mdk

* Wed Jan 12 2005 Guillaume Rousse <guillomovitch@mandrake.org> 0.8.6c-4mdk 
- move resource out of web dir too
- rediff P0 accordingly
- make cron task run with webserver uid
- use herein document instead of additional source

* Thu Jan 06 2005 Guillaume Rousse <guillomovitch@mandrake.org> 0.8.6c-3mdk 
- fix scripts encoding and perms
- rediff P0 for additional path problems in xml files

* Mon Dec 20 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.8.6c-2mdk
- fix url

* Mon Dec 20 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.8.6c-1mdk
- 0.8.6c
- fix deps
- fix P0

* Sat Oct 09 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.8.6b-1mdk
- 0.8.6b
- fix P0
- bring back perms on the scripts, duh!

* Mon Oct 04 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.8.6-3mdk
- fix P0 and S1

* Mon Oct 04 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.8.6-2mdk
- fix strange perms

* Mon Oct 04 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.8.6-1mdk
- 0.8.6
- rediffed P0 & P1
- misc spec file fixes

* Mon May 31 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 0.8.5a-1mdk
- 0.8.5a
- fixed P0
- added P1

* Tue Mar 02 2004 Tibor Pittich <Tibor.Pittich@mandrake.org> 0.8.5-1mdk
- 0.8.5
- rediff patch1
- add logrotate script
- macroszification

* Thu Nov 27 2003 Guillaume Rousse <guillomovitch@mandrake.org> 0.8.4-2mdk
- add missing lib directory

* Tue Nov 25 2003 Guillaume Rousse <guillomovitch@linux-mandrake.com> 0.8.4-1mdk
- 0.8.4
- ADVX macros
- fix files list

